class HdaAppRecipesController < ApplicationController
  auto_complete_for :hda_app_recipe, :name, :limit => 20

  def initialize
    @app_title = "Recipes"
    @app_logo ="/_PKGS/recipes/icon.png"
    @app_url ="http://recipes/"
  end

  def index
  end

  def search_recipes
    @recipes = do_search(params['hda_app_recipe']['name'])
    render :layout=>false 
  end

  def add
    @page_title = "Recipes"
  end

  def add_recipe
    HdaAppRecipe.create( {:name => params['recipe']['name'].strip,
      :description => params['recipe']['description'],
      :ingredients => params['recipe']['ingredients'],
      :instructions => params['recipe']['instructions']} )
    # render :layout => false
  end

  def create_with_ajax
    @recipe = HdaAppRecipe.new( {:name => params['recipe']['name'].strip,
      :description => params['recipe']['description'].strip,
      :ingredients => params['recipe']['ingredients'],
      :instructions => params['recipe']['instructions']} )
    @recipe.save
    render :layout => false
  end

  def get_extra_recipe_info
    @recipe = HdaAppRecipe.find(params[:id])
    render :layout => false 
  end

  def delete
    recipe = HdaAppRecipe.find(params[:id])
    recipe.destroy
    render :layout => false 
  end

  def get_all_recipes
    @recipes = HdaAppRecipe.find(:all)
    render :layout => false 
  end

  def autocomplete_recipe_name
    @recipes = do_search(params['hda_app_recipe']['name'])
    render :action => "autocomplete_recipe_list", :layout => false 
  end

  def autocomplete_recipe_description
    @recipes = do_search(params['hda_app_recipe']['description'])
    render :action => "autocomplete_recipe_list", :layout => false 
  end

protected

  def do_search(term)
    search = '%' + term.downcase + '%'
    recipes = HdaAppRecipe.find( :all,
	:conditions => [ 'LOWER(name) LIKE ?', search ],
	:order => 'name ASC',
	:limit => 15 )
    more = HdaAppRecipe.find( :all,
	:conditions => [ 'LOWER(description) LIKE ?', search ],
	:order => 'name ASC',
	:limit => 15 )
    recipes += more unless more.blank?
    more = HdaAppRecipe.find( :all,
	:conditions => [ 'LOWER(ingredients) LIKE ?', search ],
	:order => 'name ASC',
	:limit => 15 )
    recipes += more unless more.blank?
    more = HdaAppRecipe.find( :all,
	:conditions => [ 'LOWER(instructions) LIKE ?', search ],
	:order => 'name ASC',
	:limit => 15 )
    recipes += more unless more.blank?
    recipes.uniq
  end

end
