class HdaAppRecipesInstaller
  def up
    appname = "recipes"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd("#{HDA_BASE}/platform/apps/#{appname}") do
      FileUtils.cp("app/controllers/hda_app_recipes_controller.rb", "#{tgt}/app/controllers")
      FileUtils.cp("app/helpers/hda_app_recipe_helper.rb", "#{tgt}/app/helpers")
      FileUtils.cp("app/models/hda_app_recipe.rb", "#{tgt}/app/models")
      FileUtils.mkdir_p("#{tgt}/app/views/#{app}")
      FileUtils.cp_r(Dir.glob("app/views/#{app}/*.rhtml"), "#{tgt}/app/views/#{app}")
      FileUtils.mkdir_p("#{tgt}/public/images/#{app}")
      FileUtils.cp_r("public/images/.", "#{tgt}/public/images/#{app}/")
    end
    RecipeTable.migrate :up
    # pid = HdaPackage.find(:first, :conditions => "name='recipes'")[:id]
    # HdaApplication.new(:hda_package_id => pid, :hda_user_id => 1).save
    load "#{tgt}/app/models/hda_app_recipe.rb"
    load "#{tgt}/app/controllers/hda_app_recipes_controller.rb"
    load "#{tgt}/app/helpers/hda_app_recipe_helper.rb"
    true
  end

  def down
    appname = "recipes"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd(tgt) do
      FileUtils.rm("app/controllers/hda_app_recipes_controller.rb", :force => true)
      FileUtils.rm("app/helpers/hda_app_recipes_helper.rb", :force => true)
      FileUtils.rm("app/models/hda_app_recipe.rb", :force => true)
      FileUtils.rm_r("app/views/hda_app_recipes", :force => true)
      FileUtils.rm_rf("public/images/#{app}")
    end
    RecipeTable.migrate :down
    # pid = HdaPackage.find(:first, :conditions => "name='recipes'")[:id]
    # HdaApplication.find(:all, :conditions => "hda_package_id=#{pid}").each {|r| r.destroy}
    true
  end

  def user_up u
    true
  end

end

class RecipeTable < ActiveRecord::Migration
  def self.up
	begin
	    create_table :hda_app_recipes do |t|
	      t.column :name, :string
		  t.column :description, :text
		  t.column :ingredients, :text
		  t.column :instructions, :text
		end
	rescue
	end

	HdaAppRecipe.reset_column_information

	# populate database - thanks to gleb arshinov for this
	# code!
	YAML::add_domain_type("ruby/object", "HdaAppRecipe") do |type, val|
	    HdaAppRecipe.new(val)
	end
	appname = "recipes"
	app = "hda_app_" + appname
	f = open "#{HDA_BASE}/platform/apps/#{appname}/initial-recipes.yml"
	h = YAML::load(f)
	h.each do |r|
	    begin
	    	unless HdaAppRecipe.find_by_name(r.name)
	    		r.instance_variable_set "@new_record", true
	    		r.save!
	    	end
	    rescue
	    	# silence is golden
	    end
	end
	f.close
  end

  def self.down
    # dont' destroy data!
  end
end

